diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/tests/test-ns3.py ns-3.41/utils/tests/test-ns3.py
--- ns-3.40/utils/tests/test-ns3.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/tests/test-ns3.py	2024-02-09 14:44:08.633795300 -0800
@@ -1115,25 +1231,30 @@
         self.assertEqual(return_code, 0)
 
         # Now some tests will succeed normally
-        return_code, stdout, stderr = run_ns3("run \"test-runner --test-name=command-line\" --no-build")
+        return_code, stdout, stderr = run_ns3(
+            'run "test-runner --test-name=command-line" --no-build'
+        )
         self.assertEqual(return_code, 0)
 
         # Now some tests will fail during NS_COMMANDLINE_INTROSPECTION
-        return_code, stdout, stderr = run_ns3("run \"test-runner --test-name=command-line\" --no-build",
-                                              env={"NS_COMMANDLINE_INTROSPECTION": ".."}
-                                              )
+        return_code, stdout, stderr = run_ns3(
+            'run "test-runner --test-name=command-line" --no-build',
+            env={"NS_COMMANDLINE_INTROSPECTION": ".."},
+        )
         self.assertNotEqual(return_code, 0)
 
         # Cause a sigsegv
         sigsegv_example = os.path.join(ns3_path, "scratch", "sigsegv.cc")
         with open(sigsegv_example, "w", encoding="utf-8") as f:
-            f.write("""
+            f.write(
+                """
                     int main (int argc, char *argv[])
                     {
                       char *s = "hello world"; *s = 'H';
                       return 0;
                     }
-                    """)
+                    """
+            )
         return_code, stdout, stderr = run_ns3("run sigsegv")
         if win32:
             self.assertEqual(return_code, 4294967295)  # unsigned -1
@@ -1145,7 +1266,8 @@
         # Cause an abort
         abort_example = os.path.join(ns3_path, "scratch", "abort.cc")
         with open(abort_example, "w", encoding="utf-8") as f:
-            f.write("""
+            f.write(
+                """
                     #include "ns3/core-module.h"
 
                     using namespace ns3;
@@ -1154,7 +1276,8 @@
                       NS_ABORT_IF(true);
                       return 0;
                     }
-                    """)
+                    """
+            )
         return_code, stdout, stderr = run_ns3("run abort")
         if win32:
             self.assertEqual(return_code, 3)
@@ -1192,7 +1315,7 @@
         if shutil.which("git") is None:
             self.skipTest("git is not available")
 
-        return_code, _, _ = run_ns3("configure -G \"{generator}\" --enable-build-version")
+        return_code, _, _ = run_ns3('configure -G "{generator}" --enable-build-version')
         self.assertEqual(return_code, 0)
 
         return_code, stdout, stderr = run_ns3("show version")
@@ -1206,11 +1329,13 @@
         @return None
         """
 
-        test_files = ["scratch/main.cc",
-                      "scratch/empty.cc",
-                      "scratch/subdir1/main.cc",
-                      "scratch/subdir2/main.cc",
-                      "scratch/main.test.dots.in.name.cc"]
+        test_files = [
+            "scratch/main.cc",
+            "scratch/empty.cc",
+            "scratch/subdir1/main.cc",
+            "scratch/subdir2/main.cc",
+            "scratch/main.test.dots.in.name.cc",
+        ]
         backup_files = ["scratch/.main.cc"]  # hidden files should be ignored
 
         # Create test scratch files
@@ -1227,15 +1352,17 @@
                     f.write("")
 
         # Reload the cmake cache to pick them up
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\"")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}"')
         self.assertEqual(return_code, 0)
 
         # Try to build them with ns3 and cmake
         for path in test_files + backup_files:
             path = path.replace(".cc", "")
-            return_code1, stdout1, stderr1 = run_program("cmake", "--build . --target %s -j %d"
-                                                         % (path.replace("/", "_"), num_threads),
-                                                         cwd=os.path.join(ns3_path, "cmake-cache"))
+            return_code1, stdout1, stderr1 = run_program(
+                "cmake",
+                "--build . --target %s -j %d" % (path.replace("/", "_"), num_threads),
+                cwd=os.path.join(ns3_path, "cmake-cache"),
+            )
             return_code2, stdout2, stderr2 = run_ns3("build %s" % path)
             if "main" in path and ".main" not in path:
                 self.assertEqual(return_code1, 0)
@@ -1253,14 +1380,14 @@
             else:
                 self.assertEqual(return_code, 1)
 
-        # Now test them in CMake 3.10
         run_ns3("clean")
-        with DockerContainerManager(self, "ubuntu:18.04") as container:
+        with DockerContainerManager(self, "ubuntu:20.04") as container:
             container.execute("apt-get update")
-            container.execute("apt-get install -y python3 cmake g++-8 ninja-build")
+            container.execute("apt-get install -y python3 cmake g++ ninja-build")
             try:
                 container.execute(
-                    "./ns3 configure --enable-modules=core,network,internet -- -DCMAKE_CXX_COMPILER=/usr/bin/g++-8")
+                    "./ns3 configure --enable-modules=core,network,internet -- -DCMAKE_CXX_COMPILER=/usr/bin/g++"
+                )
             except DockerException as e:
                 self.fail()
             for path in test_files:
@@ -1280,16 +1407,16 @@
                 continue
             filename = os.path.basename(path).replace(".cc", "")
             executable_absolute_path = os.path.dirname(os.path.join(ns3_path, "build", path))
-            executable_name = list(filter(lambda x: filename in x,
-                                          os.listdir(executable_absolute_path)
-                                          )
-                                   )[0]
+            if os.path.exists(executable_absolute_path):
+                executable_name = list(
+                    filter(lambda x: filename in x, os.listdir(executable_absolute_path))
+                )[0]
 
-            os.remove(os.path.join(executable_absolute_path, executable_name))
+                os.remove(os.path.join(executable_absolute_path, executable_name))
             if not os.listdir(os.path.dirname(path)):
                 os.rmdir(os.path.dirname(source_absolute_path))
 
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\"")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}"')
         self.assertEqual(return_code, 0)
 
     def test_14_MpiCommandTemplate(self):
@@ -1301,7 +1428,7 @@
         if shutil.which("mpiexec") is None or win32:
             self.skipTest("Mpi is not available")
 
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-examples")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" --enable-examples')
         self.assertEqual(return_code, 0)
         executables = get_programs_list()
 
@@ -1312,8 +1439,8 @@
         # Get executable path
         sample_simulator_path = list(filter(lambda x: "sample-simulator" in x, executables))[0]
 
-        mpi_command = "--dry-run run sample-simulator --command-template=\"mpiexec -np 2 %s\""
-        non_mpi_command = "--dry-run run sample-simulator --command-template=\"echo %s\""
+        mpi_command = '--dry-run run sample-simulator --command-template="mpiexec -np 2 %s"'
+        non_mpi_command = '--dry-run run sample-simulator --command-template="echo %s"'
 
         # Get the commands to run sample-simulator in two processes with mpi
         return_code, stdout, stderr = run_ns3(mpi_command)
@@ -1325,9 +1452,14 @@
         self.assertEqual(return_code, 0)
         if os.getenv("USER", "") == "root":
             if shutil.which("ompi_info"):
-                self.assertIn("mpiexec --allow-run-as-root --oversubscribe -np 2 %s" % sample_simulator_path, stdout)
+                self.assertIn(
+                    "mpiexec --allow-run-as-root --oversubscribe -np 2 %s" % sample_simulator_path,
+                    stdout,
+                )
             else:
-                self.assertIn("mpiexec --allow-run-as-root -np 2 %s" % sample_simulator_path, stdout)
+                self.assertIn(
+                    "mpiexec --allow-run-as-root -np 2 %s" % sample_simulator_path, stdout
+                )
         else:
             self.assertIn("mpiexec -np 2 %s" % sample_simulator_path, stdout)
 
@@ -1341,7 +1473,7 @@
         self.assertEqual(return_code, 0)
         self.assertIn("echo %s" % sample_simulator_path, stdout)
 
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --disable-examples")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" --disable-examples')
         self.assertEqual(return_code, 0)
 
     def test_15_InvalidLibrariesToLink(self):
@@ -1362,15 +1494,18 @@
             f.write("")
         for invalid_or_nonexistent_library in ["", "gsd", "lib", "libfi", "calibre"]:
             with open("contrib/borked/CMakeLists.txt", "w", encoding="utf-8") as f:
-                f.write("""
+                f.write(
+                    """
                         build_lib(
                             LIBNAME borked
                             SOURCE_FILES ${PROJECT_SOURCE_DIR}/build-support/empty.cc
                             LIBRARIES_TO_LINK ${libcore} %s
                         )
-                        """ % invalid_or_nonexistent_library)
+                        """
+                    % invalid_or_nonexistent_library
+                )
 
-            return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-examples")
+            return_code, stdout, stderr = run_ns3('configure -G "{generator}" --enable-examples')
             if invalid_or_nonexistent_library in ["", "gsd", "libfi", "calibre"]:
                 self.assertEqual(return_code, 0)
             elif invalid_or_nonexistent_library in ["lib"]:
@@ -1388,7 +1523,9 @@
             elif invalid_or_nonexistent_library in ["gsd", "libfi", "calibre"]:
                 self.assertEqual(return_code, 2)  # should fail due to missing library
                 if "lld" in stdout + stderr:
-                    self.assertIn("unable to find library -l%s" % invalid_or_nonexistent_library, stderr)
+                    self.assertIn(
+                        "unable to find library -l%s" % invalid_or_nonexistent_library, stderr
+                    )
                 elif "mold" in stdout + stderr:
                     self.assertIn("library not found: %s" % invalid_or_nonexistent_library, stderr)
                 else:
@@ -1401,24 +1538,29 @@
         # - invalid library names (should fail to configure)
         # - valid library names but nonexistent libraries (should not create a target)
         with open("contrib/borked/CMakeLists.txt", "w", encoding="utf-8") as f:
-            f.write("""
+            f.write(
+                """
                     build_lib(
                         LIBNAME borked
                         SOURCE_FILES ${PROJECT_SOURCE_DIR}/build-support/empty.cc
                         LIBRARIES_TO_LINK ${libcore}
                     )
-                    """)
+                    """
+            )
         for invalid_or_nonexistent_library in ["", "gsd", "lib", "libfi", "calibre"]:
             with open("contrib/borked/examples/CMakeLists.txt", "w", encoding="utf-8") as f:
-                f.write("""
+                f.write(
+                    """
                         build_lib_example(
                             NAME borked-example
                             SOURCE_FILES ${PROJECT_SOURCE_DIR}/build-support/empty-main.cc
                             LIBRARIES_TO_LINK ${libborked} %s
                         )
-                        """ % invalid_or_nonexistent_library)
+                        """
+                    % invalid_or_nonexistent_library
+                )
 
-            return_code, stdout, stderr = run_ns3("configure -G \"{generator}\"")
+            return_code, stdout, stderr = run_ns3('configure -G "{generator}"')
             if invalid_or_nonexistent_library in ["", "gsd", "libfi", "calibre"]:
                 self.assertEqual(return_code, 0)  # should be able to configure
             elif invalid_or_nonexistent_library in ["lib"]:
@@ -1455,15 +1597,17 @@
         with open("contrib/calibre/examples/CMakeLists.txt", "w", encoding="utf-8") as f:
             f.write("")
         with open("contrib/calibre/CMakeLists.txt", "w", encoding="utf-8") as f:
-            f.write("""
+            f.write(
+                """
                 build_lib(
                     LIBNAME calibre
                     SOURCE_FILES ${PROJECT_SOURCE_DIR}/build-support/empty.cc
                     LIBRARIES_TO_LINK ${libcore}
                 )
-                """)
+                """
+            )
 
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\"")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}"')
 
         # This only checks if configuration passes
         self.assertEqual(return_code, 0)
@@ -1474,7 +1618,9 @@
         # This checks not only if "lib" from "calibre" was incorrectly removed,
         # but also if the pkgconfig file was generated with the correct name
         self.assertNotIn("care", stdout)
-        self.assertTrue(os.path.exists(os.path.join(ns3_path, "cmake-cache", "pkgconfig", "ns3-calibre.pc")))
+        self.assertTrue(
+            os.path.exists(os.path.join(ns3_path, "cmake-cache", "pkgconfig", "ns3-calibre.pc"))
+        )
 
         # Check if we can build this library
         return_code, stdout, stderr = run_ns3("build calibre")
@@ -1489,13 +1635,20 @@
         cmake_performance_trace.log file
         @return None
         """
+        cmake_performance_trace_log = os.path.join(ns3_path, "cmake_performance_trace.log")
+        if os.path.exists(cmake_performance_trace_log):
+            os.remove(cmake_performance_trace_log)
+
         return_code, stdout, stderr = run_ns3("configure --trace-performance")
         self.assertEqual(return_code, 0)
         if win32:
             self.assertIn("--profiling-format=google-trace --profiling-output=", stdout)
         else:
-            self.assertIn("--profiling-format=google-trace --profiling-output=../cmake_performance_trace.log", stdout)
-        self.assertTrue(os.path.exists(os.path.join(ns3_path, "cmake_performance_trace.log")))
+            self.assertIn(
+                "--profiling-format=google-trace --profiling-output=./cmake_performance_trace.log",
+                stdout,
+            )
+        self.assertTrue(os.path.exists(cmake_performance_trace_log))
 
     def test_18_CheckBuildVersionAndVersionCache(self):
         """!
@@ -1528,17 +1681,18 @@
             self.assertFalse(os.path.exists(os.path.join(ns3_path, "cmake-cache", "build.ninja")))
 
             # Second case: try with a version cache file but without Git (it should succeed)
-            version_cache_contents = ("CLOSEST_TAG = '\"ns-3.0.0\"'\n"
-                                      "VERSION_COMMIT_HASH = '\"0000000000\"'\n"
-                                      "VERSION_DIRTY_FLAG = '0'\n"
-                                      "VERSION_MAJOR = '3'\n"
-                                      "VERSION_MINOR = '0'\n"
-                                      "VERSION_PATCH = '0'\n"
-                                      "VERSION_RELEASE_CANDIDATE = '\"\"'\n"
-                                      "VERSION_TAG = '\"ns-3.0.0\"'\n"
-                                      "VERSION_TAG_DISTANCE = '0'\n"
-                                      "VERSION_BUILD_PROFILE = 'debug'\n"
-                                      )
+            version_cache_contents = (
+                "CLOSEST_TAG = '\"ns-3.0.0\"'\n"
+                "VERSION_COMMIT_HASH = '\"0000000000\"'\n"
+                "VERSION_DIRTY_FLAG = '0'\n"
+                "VERSION_MAJOR = '3'\n"
+                "VERSION_MINOR = '0'\n"
+                "VERSION_PATCH = '0'\n"
+                "VERSION_RELEASE_CANDIDATE = '\"\"'\n"
+                "VERSION_TAG = '\"ns-3.0.0\"'\n"
+                "VERSION_TAG_DISTANCE = '0'\n"
+                "VERSION_BUILD_PROFILE = 'debug'\n"
+            )
             with open(version_cache_file, "w", encoding="utf-8") as version:
                 version.write(version_cache_contents)
 
@@ -1584,15 +1738,18 @@
         @return None
         """
         # Try filtering enabled modules to core+network and their dependencies
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-examples --enable-tests")
-        self.config_ok(return_code, stdout)
+        return_code, stdout, stderr = run_ns3(
+            'configure -G "{generator}" --enable-examples --enable-tests'
+        )
+        self.config_ok(return_code, stdout, stderr)
 
         modules_before_filtering = get_enabled_modules()
         programs_before_filtering = get_programs_list()
 
         return_code, stdout, stderr = run_ns3(
-            "configure -G \"{generator}\" --filter-module-examples-and-tests='core;network'")
-        self.config_ok(return_code, stdout)
+            "configure -G \"{generator}\" --filter-module-examples-and-tests='core;network'"
+        )
+        self.config_ok(return_code, stdout, stderr)
 
         modules_after_filtering = get_enabled_modules()
         programs_after_filtering = get_programs_list()
@@ -1604,8 +1761,9 @@
 
         # Try filtering in only core
         return_code, stdout, stderr = run_ns3(
-            "configure -G \"{generator}\" --filter-module-examples-and-tests='core'")
-        self.config_ok(return_code, stdout)
+            "configure -G \"{generator}\" --filter-module-examples-and-tests='core'"
+        )
+        self.config_ok(return_code, stdout, stderr)
 
         # At this point we should have the same number of modules
         self.assertEqual(len(get_enabled_modules()), len(modules_after_filtering))
@@ -1614,8 +1772,9 @@
 
         # Try cleaning the list of enabled modules to reset to the normal configuration.
         return_code, stdout, stderr = run_ns3(
-            "configure -G \"{generator}\" --disable-examples --disable-tests --filter-module-examples-and-tests=''")
-        self.config_ok(return_code, stdout)
+            "configure -G \"{generator}\" --disable-examples --disable-tests --filter-module-examples-and-tests=''"
+        )
+        self.config_ok(return_code, stdout, stderr)
 
         # At this point we should have the same amount of modules that we had when we started.
         self.assertEqual(len(get_enabled_modules()), len(self.ns3_modules))
@@ -1638,7 +1797,9 @@
 
             # Check if configuration properly detected lld
             self.assertTrue(os.path.exists(os.path.join(ns3_path, "cmake-cache", "build.ninja")))
-            with open(os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r", encoding="utf-8") as f:
+            with open(
+                os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r", encoding="utf-8"
+            ) as f:
                 self.assertIn("-fuse-ld=lld", f.read())
 
             # Try to build using the lld linker
@@ -1650,8 +1811,11 @@
             # Now add mold to the PATH
             if not os.path.exists("./mold-1.4.2-x86_64-linux.tar.gz"):
                 container.execute(
-                    "wget https://github.com/rui314/mold/releases/download/v1.4.2/mold-1.4.2-x86_64-linux.tar.gz")
-            container.execute("tar xzfC mold-1.4.2-x86_64-linux.tar.gz /usr/local --strip-components=1")
+                    "wget https://github.com/rui314/mold/releases/download/v1.4.2/mold-1.4.2-x86_64-linux.tar.gz"
+                )
+            container.execute(
+                "tar xzfC mold-1.4.2-x86_64-linux.tar.gz /usr/local --strip-components=1"
+            )
 
             # Configure should detect and use mold
             run_ns3("clean")
@@ -1659,7 +1823,9 @@
 
             # Check if configuration properly detected mold
             self.assertTrue(os.path.exists(os.path.join(ns3_path, "cmake-cache", "build.ninja")))
-            with open(os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r", encoding="utf-8") as f:
+            with open(
+                os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r", encoding="utf-8"
+            ) as f:
                 self.assertIn("-fuse-ld=mold", f.read())
 
             # Try to build using the lld linker
@@ -1676,7 +1842,9 @@
 
             # Check if configuration properly disabled lld/mold usage
             self.assertTrue(os.path.exists(os.path.join(ns3_path, "cmake-cache", "build.ninja")))
-            with open(os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r", encoding="utf-8") as f:
+            with open(
+                os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r", encoding="utf-8"
+            ) as f:
                 self.assertNotIn("-fuse-ld=mold", f.read())
 
     def test_21_ClangTimeTrace(self):
@@ -1694,7 +1862,8 @@
             # Enable ClangTimeTrace without git (it should fail)
             try:
                 container.execute(
-                    "./ns3 configure -G Ninja --enable-modules=core --enable-examples --enable-tests -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10 -DNS3_CLANG_TIMETRACE=ON")
+                    "./ns3 configure -G Ninja --enable-modules=core --enable-examples --enable-tests -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10 -DNS3_CLANG_TIMETRACE=ON"
+                )
             except DockerException as e:
                 self.assertIn("could not find git for clone of ClangBuildAnalyzer", e.stderr)
 
@@ -1703,7 +1872,8 @@
             # Enable ClangTimeTrace without git (it should succeed)
             try:
                 container.execute(
-                    "./ns3 configure -G Ninja --enable-modules=core --enable-examples --enable-tests -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10 -DNS3_CLANG_TIMETRACE=ON")
+                    "./ns3 configure -G Ninja --enable-modules=core --enable-examples --enable-tests -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10 -DNS3_CLANG_TIMETRACE=ON"
+                )
             except DockerException as e:
                 self.assertIn("could not find git for clone of ClangBuildAnalyzer", e.stderr)
 
@@ -1728,8 +1898,11 @@
 
             try:
                 container.execute(
-                    "./ns3 configure -G Ninja --enable-modules=core --enable-examples --enable-tests -- -DNS3_CLANG_TIMETRACE=ON")
-                self.assertTrue(False, "ClangTimeTrace requires Clang, but GCC just passed the checks too")
+                    "./ns3 configure -G Ninja --enable-modules=core --enable-examples --enable-tests -- -DNS3_CLANG_TIMETRACE=ON"
+                )
+                self.assertTrue(
+                    False, "ClangTimeTrace requires Clang, but GCC just passed the checks too"
+                )
             except DockerException as e:
                 self.assertIn("TimeTrace is a Clang feature", e.stderr)
 
@@ -1749,7 +1922,8 @@
             # Enable Ninja tracing without using the Ninja generator
             try:
                 container.execute(
-                    "./ns3 configure --enable-modules=core --enable-ninja-tracing -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10")
+                    "./ns3 configure --enable-modules=core --enable-ninja-tracing -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10"
+                )
             except DockerException as e:
                 self.assertIn("Ninjatracing requires the Ninja generator", e.stderr)
 
@@ -1760,7 +1934,8 @@
             # Enable Ninjatracing support without git (should fail)
             try:
                 container.execute(
-                    "./ns3 configure -G Ninja --enable-modules=core --enable-ninja-tracing -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10")
+                    "./ns3 configure -G Ninja --enable-modules=core --enable-ninja-tracing -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10"
+                )
             except DockerException as e:
                 self.assertIn("could not find git for clone of NinjaTracing", e.stderr)
 
@@ -1768,7 +1943,8 @@
             # Enable Ninjatracing support with git (it should succeed)
             try:
                 container.execute(
-                    "./ns3 configure -G Ninja --enable-modules=core --enable-ninja-tracing -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10")
+                    "./ns3 configure -G Ninja --enable-modules=core --enable-ninja-tracing -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10"
+                )
             except DockerException as e:
                 self.assertTrue(False, "Failed to configure with Ninjatracing")
 
@@ -1796,7 +1972,8 @@
             # Enable Clang TimeTrace feature for more detailed traces
             try:
                 container.execute(
-                    "./ns3 configure -G Ninja --enable-modules=core --enable-ninja-tracing -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10 -DNS3_CLANG_TIMETRACE=ON")
+                    "./ns3 configure -G Ninja --enable-modules=core --enable-ninja-tracing -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10 -DNS3_CLANG_TIMETRACE=ON"
+                )
             except DockerException as e:
                 self.assertTrue(False, "Failed to configure Ninjatracing with Clang's TimeTrace")
 
@@ -1823,17 +2000,6 @@
         """
 
         run_ns3("clean")
-        # Ubuntu 18.04 ships with:
-        # - cmake 3.10: does not support PCH
-        # - ccache 3.4: incompatible with pch
-        with DockerContainerManager(self, "ubuntu:18.04") as container:
-            container.execute("apt-get update")
-            container.execute("apt-get install -y python3 cmake ccache clang-10")
-            try:
-                container.execute("./ns3 configure -- -DCMAKE_CXX_COMPILER=/usr/bin/clang++-10")
-            except DockerException as e:
-                self.assertIn("does not support precompiled headers", e.stderr)
-        run_ns3("clean")
 
         # Ubuntu 20.04 ships with:
         # - cmake 3.16: does support PCH
@@ -1863,16 +2029,37 @@
         Check for regressions in test object build.
         @return None
         """
-        return_code, stdout, stderr = run_ns3('configure')
+        return_code, stdout, stderr = run_ns3("configure")
         self.assertEqual(return_code, 0)
 
         test_module_cache = os.path.join(ns3_path, "cmake-cache", "src", "test")
         self.assertFalse(os.path.exists(test_module_cache))
 
-        return_code, stdout, stderr = run_ns3('configure --enable-tests')
+        return_code, stdout, stderr = run_ns3("configure --enable-tests")
         self.assertEqual(return_code, 0)
         self.assertTrue(os.path.exists(test_module_cache))
 
+    def test_25_CheckBareConfig(self):
+        """!
+        Check for regressions in a bare ns-3 configuration.
+        @return None
+        """
+
+        run_ns3("clean")
+
+        with DockerContainerManager(self, "ubuntu:20.04") as container:
+            container.execute("apt-get update")
+            container.execute("apt-get install -y python3 cmake g++")
+            return_code = 0
+            stdout = ""
+            try:
+                stdout = container.execute("./ns3 configure -d release")
+            except DockerException as e:
+                return_code = 1
+            self.config_ok(return_code, stdout, stdout)
+
+        run_ns3("clean")
+
 
 class NS3BuildBaseTestCase(NS3BaseTestCase):
     """!
@@ -1962,8 +2149,8 @@
             f.write("3-00\n")
 
         # Reconfigure.
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\"")
-        self.config_ok(return_code, stdout)
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}"')
+        self.config_ok(return_code, stdout, stderr)
 
         # Build.
         return_code, stdout, stderr = run_ns3("build")
@@ -2020,9 +2207,13 @@
         absolute_path = os.sep.join([ns3_path, "build", "release"])
         relative_path = os.sep.join(["build", "release"])
         for different_out_dir in [absolute_path, relative_path]:
-            return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --out=%s" % different_out_dir)
-            self.config_ok(return_code, stdout)
-            self.assertIn("Build directory               : %s" % absolute_path.replace(os.sep, '/'), stdout)
+            return_code, stdout, stderr = run_ns3(
+                'configure -G "{generator}" --out=%s' % different_out_dir
+            )
+            self.config_ok(return_code, stdout, stderr)
+            self.assertIn(
+                "Build directory               : %s" % absolute_path.replace(os.sep, "/"), stdout
+            )
 
             # Build
             run_ns3("build")
@@ -2045,8 +2236,10 @@
 
         # Restore original output directory.
         return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --out=''")
-        self.config_ok(return_code, stdout)
-        self.assertIn("Build directory               : %s" % usual_outdir.replace(os.sep, '/'), stdout)
+        self.config_ok(return_code, stdout, stderr)
+        self.assertIn(
+            "Build directory               : %s" % usual_outdir.replace(os.sep, "/"), stdout
+        )
 
         # Try re-building.
         run_ns3("build")
@@ -2082,8 +2275,10 @@
 
         # Reconfigure setting the installation folder to ns-3-dev/build/install.
         install_prefix = os.sep.join([ns3_path, "build", "install"])
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --prefix=%s" % install_prefix)
-        self.config_ok(return_code, stdout)
+        return_code, stdout, stderr = run_ns3(
+            'configure -G "{generator}" --prefix=%s' % install_prefix
+        )
+        self.config_ok(return_code, stdout, stderr)
 
         # Build.
         run_ns3("build")
@@ -2106,15 +2301,17 @@
 
         # Make sure all headers were installed.
         installed_headers = get_headers_list(install_prefix)
-        missing_headers = list(set([os.path.basename(x) for x in headers])
-                               - (set([os.path.basename(x) for x in installed_headers]))
-                               )
+        missing_headers = list(
+            set([os.path.basename(x) for x in headers])
+            - (set([os.path.basename(x) for x in installed_headers]))
+        )
         self.assertEqual(len(missing_headers), 0)
 
         # Now create a test CMake project and try to find_package ns-3.
         test_main_file = os.sep.join([install_prefix, "main.cpp"])
         with open(test_main_file, "w", encoding="utf-8") as f:
-            f.write("""
+            f.write(
+                """
             #include <ns3/core-module.h>
             using namespace ns3;
             int main ()
@@ -2124,7 +2321,8 @@
                 Simulator::Destroy ();
                 return 0;
             }
-            """)
+            """
+            )
 
         # We try to use this library without specifying a version,
         # specifying ns3-01 (text version with 'dev' is not supported)
